import org.jetbrains.kotlin.gradle.tasks.KotlinCompile

plugins {
    kotlin("jvm") version "1.6.10"
    id("com.github.johnrengelman.shadow") version "7.1.0"
    kotlin("plugin.serialization") version "1.6.10"
}

group = "nl.kallestruik"
version = "2.0"

repositories {
    mavenCentral()
    mavenLocal()
    jcenter()

    maven("https://papermc.io/repo/repository/maven-public/")
    maven("https://repo.aikar.co/content/groups/aikar/")
}

dependencies {
    implementation("co.aikar:acf-paper:0.5.0-SNAPSHOT")
    compileOnly("com.destroystokyo.paper:paper-api:1.16.5-R0.1-SNAPSHOT")
    compileOnly("nl.kallestruik:DLib:1.4.1")
    compileOnly(kotlin("stdlib-jdk8"))
    compileOnly("org.jetbrains.kotlinx:kotlinx-serialization-json:1.3.2")
}

tasks.compileJava {
    options.compilerArgs.add("-parameters")
}

tasks.shadowJar {
    relocate("co.aikar.commands", "nl.kallestruik.darena.acf")
    relocate("co.aikar.locales", "nl.kallestruik.darena.locales")
}

tasks.build {
    dependsOn(tasks.shadowJar)
}

tasks.processResources {
    expand("version" to project.version)
}

tasks.withType<KotlinCompile>() {
    kotlinOptions.jvmTarget = "13"
}
