package nl.kallestruik.darena.listeners

import nl.kallestruik.darena.managers.ArenaManager
import nl.kallestruik.darena.types.ArenaFeature
import org.bukkit.event.EventHandler
import org.bukkit.event.Listener
import org.bukkit.event.player.PlayerMoveEvent

class BorderListener(
    private val arenaManager: ArenaManager
): Listener {

    @EventHandler
    fun onMove(event: PlayerMoveEvent) {
        if (!arenaManager.shouldProcessEvent(ArenaFeature.HORIZONTAL_BORDERS, event.player))
            return

        if (event.to.y < arenaManager.currentArena!!.session!!.borderBottom.height)
            event.player.health = 0.0

        if (event.to.y > arenaManager.currentArena!!.session!!.borderTop.height)
            event.player.health = 0.0
    }
}