package nl.kallestruik.darena.listeners

import nl.kallestruik.darena.events.CheckpointReachedEvent
import nl.kallestruik.darena.managers.ArenaManager
import nl.kallestruik.darena.types.ArenaFeature
import org.bukkit.Sound
import org.bukkit.event.EventHandler
import org.bukkit.event.Listener

class CheckpointSoundListener(
    val arenaManager: ArenaManager
): Listener {

    @EventHandler
    fun onCheckpointReached(event: CheckpointReachedEvent) {
        if (!arenaManager.shouldProcessEvent(ArenaFeature.CHECKPOINT_SOUND, event.player)) {
            return
        }

        event.player.let {
            it.playSound(it.location, Sound.BLOCK_NOTE_BLOCK_BELL, 1.0F, 1.0F)
        }
    }
}