package nl.kallestruik.darena.listeners

import nl.kallestruik.darena.managers.ArenaManager
import nl.kallestruik.darena.types.ArenaFeature
import org.bukkit.entity.Player
import org.bukkit.event.EventHandler
import org.bukkit.event.Listener
import org.bukkit.event.entity.EntityDamageEvent

class FallListener(
    private val arenaManager: ArenaManager
): Listener {

    @EventHandler
    fun onDamage(event: EntityDamageEvent) {
        if (event.entity !is Player)
            return

        if (!arenaManager.shouldProcessEvent(ArenaFeature.NO_FALL, event.entity as Player))
            return

        if (event.cause == EntityDamageEvent.DamageCause.FALL
            || event.cause == EntityDamageEvent.DamageCause.FLY_INTO_WALL
        )
            event.isCancelled = true
    }
}