package nl.kallestruik.darena.listeners

import nl.kallestruik.darena.events.CheckpointReachedEvent
import nl.kallestruik.darena.managers.ArenaManager
import nl.kallestruik.darena.util.ArenaUtil
import nl.kallestruik.darena.util.Logger
import org.bukkit.event.EventHandler
import org.bukkit.event.Listener

class SectionListener(
    val arenaManager: ArenaManager,
): Listener {

    @EventHandler
    fun onCheckpointReached(event: CheckpointReachedEvent) {
        val checkpoint = event.checkpoint
        val arena = event.arena
        val uuid = event.player.uniqueId

        // Increment finished section counter for player.
        arena.session!!.finishedSectionsByPlayer[uuid] = arena.session!!.finishedSectionsByPlayer.getOrDefault(uuid, 0) + 1

        if (checkpoint.spawnPool != null) {
            val finishedSectionsByPlayer = arena.session!!.finishedSectionsByPlayer[uuid]!!
            arena.pointsSession!!.givePoolPoints(event.player, checkpoint.spawnPool, finishedSectionsByPlayer)

            Logger.debug(CheckpointListener::class, "finished count: $finishedSectionsByPlayer")
            Logger.debug(CheckpointListener::class, "Times: ${checkpoint.spawnPool.times}")
            if (finishedSectionsByPlayer >= checkpoint.spawnPool.times) {
                ArenaUtil.finishPlayer(event.player, arena, arenaManager)
                return
            }
        }
    }
}