package nl.kallestruik.darena.listeners

import nl.kallestruik.darena.managers.TeamManager
import nl.kallestruik.darena.util.Logger
import org.bukkit.event.EventHandler
import org.bukkit.event.Listener
import org.bukkit.event.player.PlayerJoinEvent

class TeamListener(
    private val teamManager: TeamManager
): Listener {

    @EventHandler
    fun onPlayerJoined(event: PlayerJoinEvent) {
        var team = teamManager.getTeamForPlayer(event.player.uniqueId)
        if (team != null) {
            team.mcTeam.addEntry(event.player.name)
            return
        }

        if (!teamManager.autoTeams)
            return

        Logger.info(TeamListener::class, "Creating automatic team for player: ${event.player.name}")
        team = teamManager.createTeam(event.player.name)
        teamManager.addPlayerToTeam(team, event.player.uniqueId)
    }
}