package nl.kallestruik.darena.managers

import nl.kallestruik.darena.types.Reloadable
import nl.kallestruik.darena.types.arena.ArenaLocation
import nl.kallestruik.darena.util.ConfigHelper
import java.io.File

class ConfigManager(
    val configFile: File,
): Reloadable {
    var spawnPos: ArenaLocation = ArenaLocation(0, 100, 0)
    var spawnWorldName = "world"
    var cooldownFireball = 30

    
    override fun reload() {
        load()
    }

    fun load() {
        val config = ConfigHelper.getOrCreateConfig(configFile, "template/config.yml")

        if (config.isConfigurationSection("spawn-pos"))
            spawnPos = ArenaLocation.load(config.getConfigurationSection("spawn-pos")!!)

        if (config.contains("spawn-world"))
            spawnWorldName = config.getString("spawn-world")!!

        if (config.contains("cooldown-fireball"))
            cooldownFireball = config.getInt("cooldown-fireball")
    }
}