package nl.kallestruik.darena.types.arena

import kotlinx.serialization.Serializable
import nl.kallestruik.darena.util.Logger
import nl.kallestruik.dlib.config.annotations.Description
import org.bukkit.Material

@Serializable
data class ArenaAllowList(
    @Description([
        "The list of rules. These rules support full regular expression. For example .*_wool will match all colors of wool."])
    var ruleList: MutableList<ArenaAllowRule> = mutableListOf(),
) {
    fun isAllowed(material: Material): Boolean {
        Logger.trace(ArenaAllowList::class, "isAllowed(material: $material)")
        for (rule in ruleList) {
            Logger.debug(ArenaAllowList::class, "Checking rule: $rule")
            return when (rule.match(material.name.lowercase())) {
                AllowRuleResult.NO_MATCH -> continue
                AllowRuleResult.ALLOWED -> true
                AllowRuleResult.BLOCKED -> false
            }
        }

        return true
    }
}