package nl.kallestruik.darena.types.arena

import kotlinx.serialization.Serializable
import nl.kallestruik.dlib.config.annotations.DefaultInt
import nl.kallestruik.dlib.config.annotations.Description
import org.bukkit.configuration.ConfigurationSection

@Serializable
data class ArenaLocation(
    @Description(["The x coordinate."])
    @DefaultInt(0)
    val x: Int,
    @Description(["The y coordinate."])
    @DefaultInt(0)
    val y: Int,
    @Description(["The z coordinate."])
    @DefaultInt(0)
    val z: Int
) {
    companion object {
        fun load(section: ConfigurationSection): ArenaLocation {
            return ArenaLocation(
                section.getInt("x", 0),
                section.getInt("y", 0),
                section.getInt("z", 0),
            )
        }
    }
}
