package nl.kallestruik.darena.types.arena

import kotlinx.serialization.SerialName
import kotlinx.serialization.Serializable
import nl.kallestruik.dlib.config.annotations.Description

@Serializable
data class ArenaPoints(
    @Description(["The points given to a player when they get a kill."])
    val kill: List<Int> = listOf(0),
    @SerialName("last-man-standing")
    @Description(["The points given to a player for staying alive the longest."])
    val lastManStanding: List<Int> = listOf(0),
    @Description(["The points given to a player for reaching a checkpoint.",
    "","Valid keys: the label of a checkpoint defined in the checkpoints section."])
    val checkpoints: Map<String, List<Int>> = mapOf(),
    @Description(["The points given to a player for reaching a checkpoint that is part of a spawn pool.",
        "The first list represents the first checkpoint, the second the second checkpoint, etc",
        "",
        "Valid keys: the names of spawn pools as defined in the spawn-pools section.",
    ])
    val pools: Map<String, List<List<Int>>> = mapOf(),
)
