package nl.kallestruik.darena.types.arena

import kotlinx.serialization.Serializable
import nl.kallestruik.dlib.config.annotations.DefaultInt
import nl.kallestruik.dlib.config.annotations.Description
import nl.kallestruik.dlib.config.annotations.MinInt

@Serializable
data class ArenaSpawnPool(
    @Description(["The name of the spawn pool."])
    val label: String,
    @Description(["The amount of spawn rules that will be chosen before a player is considered finished."])
    @MinInt(1)
    @DefaultInt(-1)
    val times: Int,
    @Description(["The list of spawn rules that the pool can choose from.",
    "", "Valid values: any spawn rule defined in the spawn-rules section."])
    val rules: List<String>
)