package nl.kallestruik.darena.types.border

import org.bukkit.plugin.java.JavaPlugin

class BorderNodeCenter(
    private val x: Double,
    private val y: Double,
): AbstractBorderNode() {

    override fun execute(border: AbstractBorder, plugin: JavaPlugin) {
        border.center(x, y)
        runNext(border, plugin)
    }

    override fun toCommand(): String {
        return "CENTER $x $y"
    }

    companion object {
        fun fromParameters(params: String): BorderNodeCenter {
            val parts = params.split(" ")
            return BorderNodeCenter(parts[0].toDouble(), parts[1].toDouble())
        }
    }
}