package nl.kallestruik.darena.util

import net.kyori.adventure.text.Component
import net.kyori.adventure.text.format.TextColor
import net.kyori.adventure.title.Title
import org.bukkit.Sound
import org.bukkit.entity.Player
import java.time.Duration


object CountdownHelper {

    fun sendTitleToAll(players: Collection<Player>, timeLeft: Int, subtitle: String) {
        for (player in players) {
            player.playSound(player.location, Sound.BLOCK_NOTE_BLOCK_BIT, 1.0F, 0.5F)
            player.showTitle(
                Title.title(
                    Component.text(timeLeft)
                        .color(TextColor.color(0xFFAA00)),
                    Component.text("$subtitle..."),
                    Title.Times.of(Duration.ZERO, Duration.ofSeconds(3), Duration.ofSeconds(2))
                ))
        }
    }

    fun sendActionBarToAll(players: Collection<Player>, timeLeft: Int, prefix: String) {
        for (player in players) {
            player.sendActionBar(
                Component.text("$prefix: ")
                    .append(
                        Component
                            .text(timeLeft)
                            .color(TextColor.color(0xFFAA00))
                    )
            )
        }
    }

    fun clearTitleForAll(players: Collection<Player>) {
        for (player in players) {
            player.clearTitle()
        }
    }

    fun clearActionBarForAll(players: Collection<Player>) {
        for (player in players) {
            player.sendActionBar(Component.empty())
        }
    }
}